<template>
  <div class="yawik-stepper-width">
    <q-card v-if="idx < questions.length" class="bg-secondary text-white">
      <q-card-section>
        <div class="text-h6">{{ $t(questions[idx].q) }}</div>
      </q-card-section>

      <q-separator dark />

      <q-card-actions v-if="!questions[idx].a" align="around">
        <q-btn color="green" size="lg" icon="thumb_up" stack no-caps @click="yes">{{ $t('buttons.yes') }}</q-btn>
        <q-btn color="red" size="lg" icon="thumb_down" stack no-caps @click="no">{{ $t('buttons.no') }}</q-btn>
      </q-card-actions>
      <q-card-actions v-else align="around">
        <q-btn
          v-for="(answer,i) in questions[idx].a"
          :key="i" size="md"
          stack
          no-caps
          @click="multiple(i)"
        >
          {{ answer }}
        </q-btn>
      </q-card-actions>
    </q-card>
    <q-card v-else class="bg-secondary text-white">
      <q-card-section class="text-h6 bg-primary">
        <div class="text-h6 bg-primary">{{ $t('Prima. Wir rufen Sie zurück.') }}</div>
      </q-card-section>

      <q-card-section>
        <div class="row q-gutter-y-md">
          <q-input
            v-model="firstname"
            bg-color="white"
            class="col-6 q-pr-sm"
            :label="$t('stepOne.firstName')"
            dense
            outlined
            :rules="[ruleRequired]"
            name="firstname"
          />
          <q-input
            v-model="lastname"
            bg-color="white"
            class="col-6 q-pl-sm"
            :label="$t('stepOne.lastName')"
            dense
            outlined
            :rules="[ruleRequired]"
            name="lastname"
          />
          <q-input
            v-model="phone"
            bg-color="white"
            icon="phone"
            class="col-12"
            :label="$t('stepOne.phone')"
            dense
            outlined
            :rules="[ruleRequired]"
            name="phone"
          >
            <template #prepend>
              <q-icon name="phone" />
            </template>
          </q-input>

          <q-input
            v-model="email"
            bg-color="white"
            icon="mail"
            class="col-12"
            :label="$t('stepOne.email')"
            dense
            outlined
            :rules="[ruleRequired, validEmail]"

            name="email"
          >
            <template #prepend>
              <q-icon name="mail" />
            </template>
          </q-input>
        </div>
      </q-card-section>

      <q-separator dark />

      <q-card-actions align="center">
        <q-btn
          size="lg"
          color="primary"
          icon="send"
          :loading="loading"
          rounded
          :disabled="!isValid()"
          no-caps
          @click="send(
            {
              firstname: firstname,
              lastname: lastname,
              phone: phone,
              email: email,
              answers: result,
              job_title: job.title
            })"
        >
          {{ $t('buttons.send') }}
          <q-tooltip>{{ $t('Bitte sagen sie uns, wer sie sind.') }}</q-tooltip>
        </q-btn>
      </q-card-actions>

      <q-card-section>
        <q-list>
          <q-item v-for="answer in result" :key="answer.i">
            <q-item-section avatar>
              <q-icon v-if="answer.a === 'yes'" size="xl" name="check" color="green" />
              <q-icon v-else-if="answer.a === 'no'" size="xl" name="close" color="red" />
              <div v-else>{{ answer.a }}</div>
            </q-item-section>
            <q-item-section side class="text-white">
              {{ questions[answer.i].q }}
            </q-item-section>
          </q-item>
        </q-list>
      </q-card-section>
    </q-card>
  </div>
</template>

<script>
import mixinValidations from 'src/lib/validations';

export default
{
  name: 'Questions',
  mixins: [mixinValidations],
  emits: ['submit'],
  props:
  {
    job:
    {
      type: Object,
      default: () =>
      {
      }
    }
  },
  data()
  {
    return {
      idx: 0,
      loading: false,
      firstname: '',
      lastname: '',
      email: '',
      phone: '',
      result: []
    };
  },
  computed:
  {
    questions()
    {
      return [
        {
          q: 'Haben Sie eine Ausbildung in der Heizungs-, Elektro- oder Kältetechnik?',
        },
        {
          q: 'Wie viele Berufserfahrung haben Sie?',
          a:
          [
            'keine',
            'in Ausbildung',
            '1-5 Jahre',
            '>5 Jahre'
          ]
        },
        {
          q: 'Haben Sie eine Fortbildung zum Meister oder Techniker?',
        },
        {
          q: 'Haben Sie bereits Erfahrung im Kundendienst-Umfeld unserer Branche?'
        }
      ];
    }
  },
  methods:
  {
    yes()
    {
      this.result.push({
        i: this.idx,
        q: this.questions[this.idx].q,
        a: this.$t('yes')
      });
      this.idx++;
    },
    no()
    {
      this.result.push({
        i: this.idx,
        q: this.questions[this.idx].q,
        a: this.$t('no')
      });
      this.idx++;
    },
    multiple(v)
    {
      this.result.push({
        i: this.idx,
        q: this.questions[this.idx].q,
        a: this.questions[this.idx].a[v]
      });
      this.idx++;
    },
    isValid()
    {
      return (
        this.firstname !== '' &&
        this.lastname !== '' &&
        this.phone !== '' &&
        this.email !== ''
      );
    },
    send(data)
    {
      this.loading = true;
      this.$axios.post('/api/candidates', {
        data: data
      }).then(response =>
      {
        console.log(response);
      }).finally(() =>
      {
        this.loading = false;
        this.$emit('submit', data);
      });
      console.log(data);
    }
  }
};
</script>
